/*
 * cdaudio_.h - Binding for the cdaudio library
 *
 *  Written by FUJIWARA Teruyoshi (tf@dsl.gr.jp)
 *  I put this program in public domain.  Use it as you like.
 *
 *  $Id: $
 */
#ifndef GAUCHE_CD_AUDIO_H
#define GAUCHE_CD_AUDIO_H

#include <gauche.h>
#include <gauche/extend.h>
#include <cdaudio.h>

/*
 * DiscInfo class
 */
typedef struct ScmDiscInfoRec {
  SCM_HEADER;
  struct disc_info di;
} ScmDiscInfo;

SCM_CLASS_DECL(Scm_DiscInfoClass);

#define SCM_DISCINFOP(obj)       SCM_XTYPEP(obj, SCM_CLASS_DISCINFO)
#define SCM_CLASS_DISCINFO       (&Scm_DiscInfoClass)
#define SCM_DISCINFO(obj)        ((ScmDiscInfo*)(obj))
#define SCM_DISCINFO_DI(obj)      (SCM_DISCINFO(obj)->di)

/*
 * Volume class
 */
typedef struct ScmVolumeRec {
  SCM_HEADER;
  struct disc_volume volume;
} ScmVolume;

SCM_CLASS_DECL(Scm_VolumeClass);

#define SCM_DISCVOLUMEP(obj)       SCM_XTYPEP(obj, SCM_CLASS_VOLUME)
#define SCM_CLASS_VOLUME       (&Scm_VolumeClass)
#define SCM_VOLUME(obj)        ((ScmVolume*)(obj))
#define SCM_VOLUME_V(obj)      (SCM_VOLUME(obj)->volume)

extern void Scm_Init_cdaudiolib(ScmModule *module);
extern ScmObj Scm_MakeDiscInfo(struct disc_info di);
extern ScmObj Scm_MakeVolume(struct disc_volume vol);

#endif
